LibreOffice LibreOffice 26.2 SDK API Reference

Included Services | Exported Interfaces | List of all members
DataSourceBrowser Service Referencepublished

implements a component which allows browsing the data sources registered on the system. More...

`import"DataSourceBrowser.idl";`

Inheritance diagram for DataSourceBrowser:

## Included Services
service | com::sun::star::form::FormController
| implements basic form controller functionality. More...
Included Services inherited from FormController
service | FormControllerDispatcher

## Exported Interfaces
interface | com::sun::star::frame::XController
| allows the component to be plugged into frames. More...
interface | com::sun::star::lang::XInitialization
| is used to initialize the browser. More...
interface | com::sun::star::frame::XDispatchProvider
| is used to control the browser from outside. More...
interface | ::com::sun::star::ui::XContextMenuInterception
| allows to intercept user-triggered context menus in the data source browser More...
Exported Interfaces inherited from FormController
interface | com::sun::star::form::XFormController
| is used for notifying the (de)activation of the controller. More...
interface | com::sun::star::awt::XTabController
interface | com::sun::star::container::XChild
interface | com::sun::star::lang::XComponent
interface | com::sun::star::container::XEnumerationAccess
interface | com::sun::star::util::XModifyBroadcaster
interface | com::sun::star::form::XConfirmDeleteBroadcaster
interface | com::sun::star::sdb::XSQLErrorBroadcaster
interface | com::sun::star::sdb::XRowSetApproveBroadcaster
interface | com::sun::star::form::XDatabaseParameterBroadcaster
Exported Interfaces inherited from FormControllerDispatcher
interface | com::sun::star::frame::XDispatchProvider

## Additional Inherited Members
Public Member Functions inherited from XController
void | attachFrame ([in] XFrame Frame)
| is called to attach the controller with its managing frame. More...
boolean | attachModel ([in] XModel Model)
| is called to attach the controller to a new model. More...
boolean | suspend ([in] boolean Suspend)
| is called to prepare the controller for closing the view More...
any | getViewData ()
| provides access to current view status More...
void | restoreViewData ([in] any Data)
| restores the view status using the data gotten from a previous call to XController::getViewData(). More...
XModel | getModel ()
| provides access to currently attached model More...
XFrame | getFrame ()
| provides access to owner frame of this controller More...
Public Member Functions inherited from XComponent
void | dispose ()
| The owner of an object calls this method to explicitly free all resources kept by this object and thus break cyclic references. More...
void | addEventListener ([in] XEventListener xListener)
| adds an event listener to the object. More...
void | removeEventListener ([in] XEventListener aListener)
| removes an event listener from the listener list. More...
Public Member Functions inherited from XInterface
any | queryInterface ([in] type aType)
| queries for a new interface to an existing UNO object. More...
void | acquire ()
| increases the reference counter by one. More...
void | release ()
| decreases the reference counter by one. More...
Public Member Functions inherited from XInitialization
void | initialize ([in] sequence< any > aArguments) raises ( com::sun::star::uno::Exception )
| initializes the object. More...
Public Member Functions inherited from XDispatchProvider
XDispatch | queryDispatch ([in] com::sun::star::util::URL URL, [in] string TargetFrameName, [in] long SearchFlags)
| searches for an XDispatch for the specified URL within the specified target frame. More...
sequence< XDispatch > | queryDispatches ([in] sequence< DispatchDescriptor > Requests)
| actually this method is redundant to XDispatchProvider::queryDispatch() to avoid multiple remote calls. More...
Protected Member Functions inherited from XDispatchProvider
XDispatch | queryDispatch ([in] com::sun::star::util::URL URL, [in] string TargetFrameName, [in] long SearchFlags)
| searches for an XDispatch for the specified URL within the specified target frame. More...
sequence< XDispatch > | queryDispatches ([in] sequence< DispatchDescriptor > Requests)
| actually this method is redundant to XDispatchProvider::queryDispatch() to avoid multiple remote calls. More...
Protected Member Functions inherited from XInterface
any | queryInterface ([in] type aType)
| queries for a new interface to an existing UNO object. More...
void | acquire ()
| increases the reference counter by one. More...
void | release ()
| decreases the reference counter by one. More...
Protected Member Functions inherited from XFormController
::com::sun::star::awt::XControl | getCurrentControl ()
void | addActivateListener ([in] ::com::sun::star::form::XFormControllerListener l)
void | removeActivateListener ([in] ::com::sun::star::form::XFormControllerListener l)
Protected Member Functions inherited from XTabController
void | setModel ([in] com::sun::star::awt::XTabControllerModel Model)
| sets the tab controller model. More...
com::sun::star::awt::XTabControllerModel | getModel ()
| returns the tab controller model. More...
void | setContainer ([in] com::sun::star::awt::XControlContainer Container)
| set the control container. More...
com::sun::star::awt::XControlContainer | getContainer ()
| returns the control container. More...
sequence< com::sun::star::awt::XControl > | getControls ()
| returns all controls of the control container. More...
void | autoTabOrder ()
| enables automatic tab order. More...
void | activateTabOrder ()
| activates tab order. More...
void | activateFirst ()
| sets the focus to the first control that can be reached with the TAB key. More...
void | activateLast ()
| sets the focus to the last control that can be reached with the TAB key. More...
Protected Member Functions inherited from XChild
com::sun::star::uno::XInterface | getParent ()
| grants access to the object containing this content. More...
void | setParent ([in] com::sun::star::uno::XInterface Parent) raises ( com::sun::star::lang::NoSupportException )
| sets the parent to this object. More...
Protected Member Functions inherited from XComponent
void | dispose ()
| The owner of an object calls this method to explicitly free all resources kept by this object and thus break cyclic references. More...
void | addEventListener ([in] XEventListener xListener)
| adds an event listener to the object. More...
void | removeEventListener ([in] XEventListener aListener)
| removes an event listener from the listener list. More...
Protected Member Functions inherited from XEnumerationAccess
com::sun::star::container::XEnumeration | createEnumeration ()
Protected Member Functions inherited from XElementAccess
type | getElementType ()
boolean | hasElements ()
Protected Member Functions inherited from XModifyBroadcaster
void | addModifyListener ([in] com::sun::star::util::XModifyListener aListener)
| adds the specified listener to receive events "modified." More...
void | removeModifyListener ([in] com::sun::star::util::XModifyListener aListener)
| removes the specified listener. More...
Protected Member Functions inherited from XConfirmDeleteBroadcaster
void | addConfirmDeleteListener ([in] com::sun::star::form::XConfirmDeleteListener aListener)
| remembers the specified listener to receive an event for confirming deletions More...
void | removeConfirmDeleteListener ([in] com::sun::star::form::XConfirmDeleteListener aListener)
| removes the specified listener. More...
Protected Member Functions inherited from XSQLErrorBroadcaster
void | addSQLErrorListener ([in]XSQLErrorListener Listener)
| adds the specified listener to receive the event "errorOccurred" More...
void | removeSQLErrorListener ([in]XSQLErrorListener Listener)
| removes the specified listener. More...
Protected Member Functions inherited from XRowSetApproveBroadcaster
void | addRowSetApproveListener ([in]XRowSetApproveListener listener)
| adds the specified listener to receive the events "approveCursorMove", "approveRowChange", and "approveRowSetChange". More...
void | removeRowSetApproveListener ([in]XRowSetApproveListener listener)
| removes the specified listener. More...
Protected Member Functions inherited from XDatabaseParameterBroadcaster
void | addParameterListener ([in] com::sun::star::form::XDatabaseParameterListener aListener)
| adds the specified listener, to allow it to fill in necessary parameter values. More...
void | removeParameterListener ([in] com::sun::star::form::XDatabaseParameterListener aListener)
| removes the specified listener. More...
Protected Member Functions inherited from XController
void | attachFrame ([in] XFrame Frame)
| is called to attach the controller with its managing frame. More...
boolean | attachModel ([in] XModel Model)
| is called to attach the controller to a new model. More...
boolean | suspend ([in] boolean Suspend)
| is called to prepare the controller for closing the view More...
any | getViewData ()
| provides access to current view status More...
void | restoreViewData ([in] any Data)
| restores the view status using the data gotten from a previous call to XController::getViewData(). More...
XModel | getModel ()
| provides access to currently attached model More...
XFrame | getFrame ()
| provides access to owner frame of this controller More...
Protected Member Functions inherited from XInitialization
void | initialize ([in] sequence< any > aArguments) raises ( com::sun::star::uno::Exception )
| initializes the object. More...
Protected Member Functions inherited from XContextMenuInterception
void | registerContextMenuInterceptor ([in]XContextMenuInterceptor Interceptor)
| registers an XContextMenuInterceptor, which will become the first interceptor in the chain of registered interceptors. More...
void | releaseContextMenuInterceptor ([in]XContextMenuInterceptor Interceptor)
| removes an XContextMenuInterceptor which was previously registered using XContextMenuInterception::registerContextMenuInterceptor(). More...

## Detailed Description

implements a component which allows browsing the data sources registered on the system.

This service implements a user interface for browsing data sources registered on the com::sun::star::sdb::DatabaseContext instance of the system.

It is possible to navigate through all the data sources, it's queries and it's tables. The queries/tables can be displayed in a grid-like view, where functionality for searching, sorting, filtering, and such is provided.

Usually, you won't instantiate this service directly, instead you use the dispatch mechanisms of the application framework to load the URL .component:DB/DataSourceBrowser into an arbitrary frame. This should involve a com::sun::star::sdb::ContentLoader service, which creates and initializes the browser.

Some aspects of the browser can be controlled from outside, e.g., it is possible to dispatch a sort or filter request, if a table or query is being displayed.

The communication between the browser and external instances works in two ways.
The way in is provided by the com::sun::star::frame::XDispatchProvider interface the service exports (Please see below for more details on this).
The way out works in another way. There are several URLs which an external instance can provide dispatches for (usually by implementing a com::sun::star::frame::XDispatchProviderInterceptor for the parent frame of the browser), thus indicating that the browser should provide special functionality.
In this case, the browser displays and maintains some additional slots (to be more concrete: toolbox items), which, upon triggering, call the com::sun::star::frame::XDispatch::dispatch() method of the object provided by the external instance.

In particular, the supported URLs for communicating to an external instance are:

- .uno:DataSourceBrowser/InsertColumns
  Available whenever an external instance provides a dispatcher ( com::sun::star::frame::XDispatch) for this URL.
  Enabled, if at least one row in the grid view of a table or query is selected.
  It is the task of the external instance to provide functionality for this URL, but usually it is used to implement some kind of "Data To Text" functionality.
- .uno:DataSourceBrowser/InsertContent
  Available whenever an external instance provides a dispatcher( com::sun::star::frame::XDispatch ) for this URL.
  Enabled, if at least one row in the grid view of a table or query is selected.
  It is the task of the external instance to provide functionality for this URL, but usually it is used to implement some kind of "Data To Fields" functionality.
- .uno:DataSourceBrowser/FormLetter
  Available whenever an external instance provides a dispatcher ( com::sun::star::frame::XDispatch) for this URL.
  It is the task of the external instance to provide functionality for this URL, but usually it is used to implement some kind of "Form Letter" functionality.

For all kinds of URLs, the parameters supplied during dispatching build up a DataAccessDescriptor, where the following properties are present:

- DataAccessDescriptor::DataSourceName
- DataAccessDescriptor::Command
- DataAccessDescriptor::CommandType
- optional DataAccessDescriptor::Selection
- optional DataAccessDescriptor::BookmarkSelection
- optional DataAccessDescriptor::ResultSet

The default for DataAccessDescriptor::Selection is to contain bookmarks, if not specified otherwise by DataAccessDescriptor::BookmarkSelection.

See also
  com::sun::star::sdb::ContentLoader
  com::sun::star::sdb::DatabaseContext
  com::sun::star::sdb::DataSource
  com::sun::star::frame::XDispatch
  com::sun::star::frame::XDispatchProvider
  com::sun::star::frame::XDispatchProviderInterceptor

Developers Guide
  Office Development - Component - Controllers - Document Specific Controller Services

## Exported Interfaces

## ◆ com::sun::star::form::FormController

service com::sun::star::form::FormController
| optional

implements basic form controller functionality.

With a data source browser implementing this interface, external components have access to

- the grid control which is used to display the currently selected table/query (see com::sun::star::awt::XTabController::getControls())
- the data form used for displaying objects. As always for components implementing this service, the object returned by com::sun::star::awt::XTabController::getModel() is a dataform.

## Exported Interfaces

## ◆ ::com::sun::star::ui::XContextMenuInterception

interface ::com::sun::star::ui::XContextMenuInterception
| optional

allows to intercept user-triggered context menus in the data source browser

Context menu interception is currently supported only for the browser control where the registered data sources and all their tables and queries are displayed in a tree view.

The selection supplied by com::sun::star::ui::ContextMenuExecuteEvent::Selection, in the event structure passed to the context menu interceptors, actually is a value from the com::sun::star::sdb::application::NamedDatabaseObject group.

Since
  OOo 3.0

## ◆ com::sun::star::frame::XController

interface com::sun::star::frame::XController

allows the component to be plugged into frames.

## ◆ com::sun::star::frame::XDispatchProvider

interface com::sun::star::frame::XDispatchProvider

is used to control the browser from outside.

You may use the com::sun::star::frame::XDispatchProvider::queryDispatch() method to query for objects which implement the com::sun::star::frame::XDispatch interface, and which allow you to be notified on status changes and to dispatch special requests.

The recognized URLs are:

- .uno:Copy
  implements the usual Copy command. Enabled if the grid view has the focus and text in any cell is selected.
- .uno:Cut
  implements the usual Cut command. Enabled if the grid view has the focus and text in any cell is selected.
- .uno:Paste
  implements the usual Paste command. Enabled if the grid view has the focus and a cell which allows text input is being edited.
- .uno:EditDoc
  allows switching the edit mode of the grid view. Enabled if editing the data is allowed in general.
- .uno:Undo
  revokes any changes done in the current row.
- .uno:Save
  saves the changes done in the current row.

## ◆ com::sun::star::lang::XInitialization

interface com::sun::star::lang::XInitialization

is used to initialize the browser.

Parameters (passed to the method com::sun::star::lang::XInitialization::initialize()) have to be instances of com::sun::star::beans::PropertyValue, or instances of com::sun::star::beans::NamedValue, where the `Name` member specifies what the parameter controls, with the `Value` member containing the value to be used.
Recognized parameters are:

- Frame
  has to be an com::sun::star::frame::XFrame interface specifying the frame to plug the browser component into.

- DataSourceName
  The name of the globally registered DataSource to be used for initial display. It is only meaningful together with the other parameters specifying the object to display.

- CommandType
  This has to be a CommandType value, specifying the type of the object to display initially. It is only meaningful together with the DataSourceName and the Command parameters.

- Command
  This is a string giving the name of the object to display initially. Whether it is table name, a query name or a SQL string is controller by the CommandType parameter.

- EnableBrowser
  is a boolean value (defaulting to `TRUE`), which specifies whether to enable the data source browser control. This is a tree control on the left hand side of the view, which allows to browse all registered data sources, including their tables and queries.

- ShowBrowser
  is a boolean value (defaulting to `TRUE`), which specifies whether to initially show the data source browser control. If `EnableBrowser` is `FALSE`, then this parameter is ignored. If `EnableBrowser` is `TRUE`, and `ShowBrowser` is `FALSE`, then the control is initially hidden, but can be toggled by a toolbar button.

- ShowMenu
  is a boolean value (defaulting to `TRUE`), specifying whether or not to show a menu in the frame where the component is plugged.

The documentation for this service was generated from the following file:

- com/sun/star/sdb/DataSourceBrowser.idl